# -*- coding: UTF-8 -*-
#
# Скрипт сбора информации о состоянии sync
#

from plugins import backupFile
import optparse
import queuesManager
import sys
import os


def lastUnloadTimestamp():
    """
    Получаем дату последней выгрузки продаж из backup архивов.
    Используется для zabbix метрики.
    """
    lastTime = None
    if sys.version_info[0] == 3:
        with os.scandir(backupFile.prepareDirectory('sales')) as it:
            unloadTime = lambda entry: int(entry.name.split('_')[1])
            lastTime = unloadTime(max(it, default=None, key=unloadTime))
    else:
        files = os.listdir(backupFile.prepareDirectory('sales'))
        if files:
            unloadTime = lambda name: int(name.split('_')[1])
            lastTime = unloadTime(max(files, key=unloadTime))

    print(lastTime)


def taskQueueSize():
    """
    Считаем количество задач на выгрузку в очереди.
    Используется для zabbix метрики.
    """
    sizeUnload = queuesManager.getUnloadTasksQueueSize()
    sizeUnloaded = queuesManager.getUnloadedSalesTasksQueueSize()
    if sizeUnload is None or sizeUnloaded is None:
        print(None)
        return

    print(sizeUnload + sizeUnloaded)


if __name__ == '__main__':
    parser = optparse.OptionParser()
    parser.add_option("-l", "--last-unload", action="store_true", dest="lastUnload", default=False, help="Return last unload timestamp")
    parser.add_option("-q", "--queue-size", action="store_true", dest="queueSize", default=False, help="Return size of task queue")
    (options, args) = parser.parse_args()
    if not sys.argv[1:]:
        parser.print_help()
        sys.exit(0)
    if options.lastUnload:
        lastUnloadTimestamp()
        sys.exit(0)
    if options.queueSize:
        taskQueueSize()
        sys.exit(0)
